TTYOFF:TRUE;
SYMAXX_CreatePlotdata([Args]):=BLOCK(
 [NUMER:TRUE,DISPLAY2D:FALSE,
 MyVar,
 MyRange,
 MyPts:101,
 MyFuncData,
 MyFuncX,
 MyFuncY,
 MyMin,MyMax,
 MyStep,
 MyTitle:"",
 MyResX,
 MyResY,
 MyResList:[],
 MySmooth:"",
 Indep,
 MyMode:"LIN",
 MyListplot:0,
 RangeError:"RANGE must be [var,min,max]"], 
 TTYOFF:FALSE,

 IF AT('F,Args) # 'F THEN MyFuncData:AT('F,Args) ELSE ERROR("No function F given"),
 IF AT('PTS,Args) # 'PTS THEN MyPts:AT('PTS,Args),
 IF AT('RANGE,Args) # 'RANGE THEN MyRange:AT('RANGE,Args),
 IF AT('CURVETITLE,Args) # 'CURVETITLE THEN MyTitle:AT('CURVETITLE,Args),
 IF AT('SMOOTH,Args) # 'SMOOTH THEN MySmooth:AT('SMOOTH,Args),
 IF AT('LINLOG,Args) # 'LINLOG THEN MyMode:AT('LINLOG,Args),
 IF AT('LISTPLOT,Args) # 'LISTPLOT THEN MyListplot:AT('LISTPLOT,Args),
 
  if MyListplot # TRUE then block(
   
    if MyMode # "LIN" AND MyMode # "LOG" then ERROR("LINLOG must be LIN or LOG, not ",MyMode),
 IF (MyListplot # TRUE and (NOT LISTP(MyRange) OR LENGTH(MyRange) # 3)) THEN ERROR(RangeError),
 MyVar:MyRange[1],MyMin:ev(MyRange[2]),MyMax:ev(MyRange[3]),
 if MyMode = "LOG" AND MyMin*MyMax<0 then ERROR("Logscale: Range must not include 0"),
 IF NOT ATOM(MyVar) THEN ERROR(RangeError),
 IF NOT NUMBERP(MyMin) OR NOT NUMBERP(MyMax) OR MyMin>=MyMax THEN ERROR(RangeError),
 IF NOT NUMBERP(MyPts) OR NOT MyPts>1 THEN ERROR("PTS must be number > 1"), 
 if (MyMode="LIN") THEN MyStep:(MyMax-MyMin)/(MyPts-1),
 if (MyMode="LOG") THEN MyStep:(MyMax/MyMin)^(1/(MyPts-1)),

 /* Provisional X and Y function (for non-parametric only) */
 /* If parametric, then they are overwritten. */
 MyFuncX:'Indep,
 MyFuncY:MyFuncData,

 if (LISTP(MyFuncData)) THEN (
  IF LENGTH(MyFuncData) # 2 then ERROR("Parametric plot needs [f(x),g(x)] - two elements"),
  MyFuncX:MyFuncData[1],
  MyFuncY:MyFuncData[2]
  ), /* if given function is list */

 Indep:MyMin,
 WHILE Indep<=MyMax*1.001 DO BLOCK(
  /* Errcatch will wrap the result into a list. */
  /* If an error occurs, we create a line [x,NAN] instead. */
  /* This will be replaced later with a blank line, when GNUPLOTting. */  
  MyResY:ERRCATCH(ev(MyFuncY,ev(MyVar)=Indep,numer,eval)),
  MyResX:ERRCATCH(ev(MyFuncX,ev(MyVar)=Indep,numer,eval)),
  IF(MyResX # [] AND MyResY # []) THEN (
   MyResX:MyResX[1], /* Retrieve result from ERRCATCH list-wrapping */
   MyResY:MyResY[1], /* Retrieve result from ERRCATCH list-wrapping */
   MyResList:APPEND(MyResList,[[MyResX,MyResY]]),
   IF NOT (NUMBERP(MyResX) AND NUMBERP(MyResY)) THEN ERROR("not numeric: ",MyResX,MyResY)
   ) ELSE ( /* If error, for example division by zero */
     /* Append NAN only in non-parametric mode. */
    IF (NOT (LISTP(MyFuncData))) THEN MyResList:APPEND(MyResList,[[Ind,'NAN]])
   ), /* If not error */
  if MyMode="LIN" THEN Indep:ev(Indep+MyStep,numer),
  if MyMode="LOG" THEN Indep:ev(Indep*MyStep,numer)
  ), /* For x */
 MyResList:[DATA=MyResList]) /* if not listplot */
 else
 MyResList:[DATA=MyFuncData],
 
 IF MyTitle # "" THEN MyResList:append(MyResList,['CURVETITLE=MyTitle]),
 IF MySmooth # "" THEN MyResList:append(MyResList,['SMOOTH=MySmooth]),
 return(FUNMAKE('SYMAXX_GNUPLOT_DATA,MyResList))
 );/* Block */

SYMAXX_CreatePlotdataBackup([Args]):=BLOCK(
 [NUMER:TRUE,DISPLAY2D:FALSE,
 MyVar,
 MyRange,
 MyPts:101,
 MyFunc,
 MyMin,MyMax,
 MyStep,
 MyTitle:"",
 MyRes,
 MyResList:[],
 MySmooth:"",
 Indep,
 MyMode:"LIN",
 RangeError:"RANGE must be [var,min,max]"],
 IF AT('F,Args) # 'F THEN MyFunc:AT('F,Args) ELSE ERROR("No function F given"),
 IF AT('PTS,Args) # 'PTS THEN MyPts:AT('PTS,Args),
 IF AT('RANGE,Args) # 'RANGE THEN MyRange:AT('RANGE,Args),
 IF AT('CURVETITLE,Args) # 'CURVETITLE THEN MyTitle:AT('CURVETITLE,Args),
 IF AT('SMOOTH,Args) # 'SMOOTH THEN MySmooth:AT('SMOOTH,Args),
 IF AT('LINLOG,Args) # 'LINLOG THEN MyMode:AT('LINLOG,Args),
 if MyMode # "LIN" AND MyMode # "LOG" then ERROR("LINLOG must be LIN or LOG, not ",MyMode),
 IF NOT LISTP(MyRange) OR LENGTH(MyRange) # 3 THEN ERROR(RangeError),
 MyVar:MyRange[1],MyMin:ev(MyRange[2]),MyMax:ev(MyRange[3]),
 if MyMode = "LOG" AND MyMin*MyMax<0 then ERROR("Logscale: Range must not include 0"),
 IF NOT ATOM(MyVar) THEN ERROR(RangeError),
 IF NOT NUMBERP(MyMin) OR NOT NUMBERP(MyMax) OR MyMin>=MyMax THEN ERROR(RangeError),
 IF NOT NUMBERP(MyPts) OR NOT MyPts>1 THEN ERROR("PTS must be number > 1"), 
 if (MyMode="LIN") THEN MyStep:(MyMax-MyMin)/(MyPts-1),
 if (MyMode="LOG") THEN MyStep:(MyMax/MyMin)^(1/(MyPts-1)),
 Indep:MyMin,
 WHILE Indep<=MyMax*1.001 DO BLOCK(
  /* Errcatch will wrap the result into a list. */
  /* If an error occurs, we create a line [x,NAN] instead. */
  /* This will be replaced later with a blank line, when GNUPLOTting. */  
  MyRes:ERRCATCH(ev(AT(ev(MyFunc),ev(MyVar)=Indep),numer,eval)),
  IF(MyRes # []) THEN (
   MyRes:MyRes[1], /* Retrieve result from ERRCATCH list-wrapping */
   MyResList:APPEND(MyResList,[[Indep,MyRes]]),
   IF NOT (NUMBERP(Indep) AND NUMBERP(MyRes)) THEN ERROR("not numeric: ",Indep,MyRes)) ELSE (
   MyResList:APPEND(MyResList,[[Indep,'NAN]])
   ), /* If not error */
  if MyMode="LIN" THEN Indep:Indep+MyStep,
  if MyMode="LOG" THEN Indep:Indep*MyStep
  ), /* For x */
 MyResList:[DATA=MyResList],
 IF MyTitle # "" THEN MyResList:append(MyResList,['CURVETITLE=MyTitle]),
 IF MySmooth # "" THEN MyResList:append(MyResList,['SMOOTH=MySmooth]),
 return(FUNMAKE('SYMAXX_GNUPLOT_DATA,MyResList))
 );/* Block */

SYMAXX_GNUPLOT([Args]):=BLOCK([
 PlotCount,
 LineCount,
 PlotCmd:"",
 EPSFilename:concat(SymaxxTempDir,"plot_ID_",string(SYMAXX_ID),"_INDEX_",string(SYMAXX_INDEX),".eps"),
 TempFile,
 CommandString,
 CommandList:[],
 AllData:AT('DATA,Args),
 DiagramTitle:"",
 Logscale:"",
 Grid:"",
 MyScale:1,
 MyLabelX:"",
 MyLabelY:"",
 MyRangeX:"",
 MyRangeY:"",
 MyColour:"",
 NoDataError:"Argument is not a data object-pos"
 ],
 /* Fun(DATA=Arg) => [Arg] - Conversion needed.
    Fun(DATA=[Arg,Arg]) => [Arg,Arg] */
 IF NOT LISTP(AllData) THEN AllData:[AllData],
 IF AT('DIAGTITLE,Args) # 'DIAGTITLE THEN DiagramTitle:AT('DIAGTITLE,Args),
 IF AT('LINLOGX,Args) # 'LINLOGX THEN Logscale:"x",
 IF AT('LINLOGY,Args) # 'LINLOGY THEN Logscale:concat(Logscale,"y"),
 IF AT('GRIDX,Args) # 'GRIDX THEN Grid:"xtics mxtics ",
 IF AT('GRIDY,Args) # 'GRIDY THEN Grid:concat(Grid," ytics mytics"),
 IF AT('SCALE,Args) # 'SCALE THEN MyScale:AT('SCALE,Args),
 IF AT('LABELX,Args) # 'LABELX THEN MyLabelX:AT('LABELX,Args),
 IF AT('LABELY,Args) # 'LABELY THEN MyLabelY:AT('LABELY,Args),
 IF AT('RANGEX,Args) # 'RANGEX THEN MyRangeX:AT('RANGEX,Args),
 IF AT('RANGEY,Args) # 'RANGEY THEN MyRangeY:AT('RANGEY,Args),
 IF AT('COLOUR,Args) # 'COLOUR THEN MyColour:AT('COLOUR,Args),
 FOR PlotCount1:1 THRU LENGTH(AllData) DO BLOCK(
  [
  PlotSmooth:"",
  PlotCount2,
  PlotCommand:AllData[PlotCount1],
  PlotCommandArgs,
  PlotCommandData],  
  TempFile:concat(SymaxxTempDir,"plot",PlotCount1,".data"),
  IF ATOM(PlotCommand) THEN ERROR(NoDataError,PlotCount1),
  IF NOT (INPART(PlotCommand,0)='SYMAXX_GNUPLOT_DATA) THEN ERROR(NoDataError,PlotCount1),
  PlotCommandArgs:ARGS(PlotCommand),
  IF AT('DATA,PlotCommandArgs) # 'DATA THEN PlotData:AT('DATA,PlotCommandArgs) ELSE ERROR("No DATA given"),

  /* This is a workaround to a strange bug concerning file I/O. */
  
  print("Opening",TempFile),
  system("rm ",TempFile), /* Clear the data file */
   FOR PlotCount2:1 THRU length(PlotData) DO BLOCK(
    [MyIndep:PlotData[PlotCount2][1],
    MyDep:PlotData[PlotCount2][2]],
    IF(NUMBERP(MyIndep) AND NUMBERP(MyDep)) THEN
    /* Create a data line */ 
    system("echo ",MyIndep," ",MyDep," >> ",TempFile) ELSE 
    /* Create a blank line */
    system("echo \"\" >> ",TempFile) 
    ) /* For PlotCount2 */
  ),/* For PlotCount1 */
  CommandList:[concat("set term postscript eps enhanced ",MyColour),
   concat("set output \\\"",EPSFilename,"\\\"")],
   if DiagramTitle # "" THEN CommandList:append(CommandList,[concat("set title \\\"",DiagramTitle,"\\\"")]), 
   if Logscale # "" THEN CommandList:append(CommandList,[concat("set logscale ",Logscale)]),
   if Grid # "" THEN CommandList:append(CommandList,[concat("set grid ",Grid)]),
   if MyLabelX # "" THEN CommandList:append(CommandList,[concat("set xlabel \\\"",MyLabelX,"\\\"")]),
   if MyLabelY # "" THEN CommandList:append(CommandList,[concat("set ylabel \\\"",MyLabelY,"\\\"")]),
   if MyRangeX # "" THEN CommandList:append(CommandList,[concat("set xrange [",MyRangeX,"]")]),
   if MyRangeY # "" THEN CommandList:append(CommandList,[concat("set yrange [",MyRangeY,"]")]),
   CommandString:"plot ",
   for PlotCount1:1 THRU LENGTH(AllData) DO BLOCK(
   [PlotData:ARGS(AllData[PlotCount1])],
    if PlotCount1 >1 THEN CommandString:concat(CommandString,","),
    /* \\\" means: \" in shell, " in file */
    CommandString:concat(CommandString,"\\\"",SymaxxTempDir,"plot",PlotCount1,".data\\\""),
    IF AT('SMOOTH,PlotData) # 'SMOOTH then CommandString:concat(CommandString," smooth ",AT('SMOOTH,PlotData)),
    IF AT('CURVETITLE,PlotData) # 'CURVETITLE then CommandString:concat(CommandString," title \\\"",AT('CURVETITLE,PlotData),"\\\"") 
    else CommandString:concat(CommandString," notitle") 
    ), /* Block For PlotCount1*/
  CommandList:append(CommandList,[CommandString]),
  TempFile:concat(SymaxxTempDir,"gnuplot.command"),
  system("rm ",TempFile), /* Clear the data file */

  /* Write the list of gnuplot commands to a file */
  for PlotCount1:1 thru LENGTH(CommandList) do
   system("echo \"",CommandList[PlotCount1],"\" >> ",TempFile),
   
  /* ... and run that file through Gnuplot. */
  system("gnuplot ",TempFile),

  /* This function returns an 'object' EPS(Filename,1). 1 is scale. */
  RETURN(funmake('EPS,[EPSFilename,MyScale]))
);/* Block */
TTYOFF:FALSE;
