TTYOFF:TRUE;NOLABELS:TRUE;

/* Error messages are mangled and mutilated by the 2d display (for example: Try
ev(1,REF[3]);
Therefore turn it off.*/	
DISPLAY2D:FALSE;		
SYMAXX_ResetError():=(errcatch(error("[NO_ERROR]")))$
SYMAXX_Eval(MyArg):=block([Res],
 Res:errcatch(
  ev(MyArg),"OK"
  ), /*Errcatch*/
 if Res # "OK" THEN ErrorReporter
 )/* block SYMAXX_Eval*/$
/* Redefine %TH function */
%TH(Index):=BLOCK(
	  [L:LENGTH(SYMAXX_HISTORY)],
	IF Index>L then ERROR("SYMAXX-ERROR - %TH()"),
	SYMAXX_HISTORY[Index]
)$
SYMAXX_CLEAR_HISTORY():=(SYMAXX_HISTORY:[],DONE)$
SYMAXX_PUSH_INTO_HISTORY(arg):=
  block(
        SYMAXX_HISTORY:append([arg],SYMAXX_HISTORY),
    DONE
)$
    
MATCHDECLARE(
	     ProtMul,TRUE,		
	     ProtName,TRUE,		/* ProtMul*SEL(ProtContent,ProtName)^ProtPower */
	     ProtContent,TRUE,
	     ProtContent2,TRUE,
	     ProtPower,TRUE, /* */
	     ProtRest,TRUE,
	     SYMAXX_Placeholder_Number,integerp(),
	     SYMAXXIntVar,integerp(),
	     MinusOne,equal(-1)
)$
DEFMATCH(SelSimpMatch,ProtMul*SEL(ProtContent,ProtName))$
DEFMATCH(SelSimpMulMatch,ProtMul*SEL(ProtContent,ProtName)^ProtPower)$
DEFMATCH(SelSimpMulMatch2,ProtMul*SEL(ProtContent,ProtName))$
DEFMATCH(SelSimpDivMatch,ProtMul/SEL(ProtContent,ProtName))$

SYMAXX_RememberVars():=block(SYMAXX_OLD_VARLIST:append(VALUES,[1]),return(DONE));
SYMAXX_KillVars():=block([v:append(VALUES,[]),Count1,Count2,GotIt,Victim,VictimB],
 error("Does not work"),
 /* We have to make a copy of VALUES, because it will change. */
FOR Count1:1 thru length(v) do (
 GotIt:NIL,
 for Count2:1 thru length(SYMAXX_OLD_VARLIST) do(
  if SYMAXX_OLD_VARLIST[Count2]=v[Count1] then GotIt:TRUE
  ), /* For Count2 */
  if GotIt=NIL then (Victim:v[Count1],
     
     ldisplay(VictimB),
     VictimB:[Victim],
    if Victim # 'SYMAXX_OLD_VARLIST 
    and Victim # 'Count1 
    and Victim # 'Count2 
    and Victim # 'v 
    and Victim # 'GotIt  then kill(''(VictimB[1]))
)
 ), /* For Count1 */
return(DONE)
);

/* #############################################################################################################
   ### GetVar(var) function:                                                                                 ###
   ### Gets an expression expr from a list [a1=expr1,a2=expr2,...]                                           ###
   #############################################################################################################
*/

SYMAXX_GetVar(SearchVar,Expr):=catch(block([l,Count,Subexpr],
 if not LISTP(Expr) THEN ERROR("SYMAXX_GetVar needs a list for Arg 2!"),
   l:LENGTH(Expr),
   FOR Count:1 THRU l DO (
    Subexpr:PART(Expr,Count),
    if is(length(Subexpr) # 2) then error("Argument",Subexpr,"is not a=b"),
    if is(inpart(Subexpr,0) # "=") then error("Argument",Subexpr,"is not a=b"),
    if is(part(Subexpr,1)=SearchVar) then throw(rhs(Subexpr,2))
    ), /* for */
   throw(NIL)
   )
  )$


/* #############################################################################################################
   ### RefEval function:                                                                                     ###
   ### Evaluates all the REF[x] statements without evaluating the whole expression.                          ###
   #############################################################################################################
*/

defrule(SYMAXXRefEval,REF[SYMAXXIntVar],REF[SYMAXXIntVar])$

/* #############################################################################################################
   ### Error reporter: prints a keyword, when an error occurs.                                               ###
   ### Symaxx will look for that keyword when scanning through the output.                                   ###
   #############################################################################################################
*/

ErrorReporter():=block(
 if ERROR[1] # "No error." 
 then block([TTYOFF:FALSE,Count],
  print("[MAXIMA-ERROR-START]"),
  print(ERROR[1]),
  FOR Count:2 THRU LENGTH(ERROR) STEP 1 DO
  PRINT("[MAXIMA-ERROR-ITEM]",ERROR[Count]),
  PRINT("[MAXIMA-ERROR-END]"),
  SYMAXX_ResetError()
  ) /* block (then) */
 )$

/* #############################################################################################################
   ### Instant solve: Solve for a subexpression.                                                             ###
   ### First substitute the subexpression with a variable, then solve for that variable.                     ###
   ### Finally resubstitute the subexpression and convert a one-element list to its contents.                ###
   #############################################################################################################
*/

InstantSolve(Expression,Subexpression):=Block(
	[InstantSolveSubst,InstantSolveIntermediate,Res],
	InstantSolveIntermediate:Ratsubst(InstantSolveSubst,Subexpression,Expression),
					  Res:ratsubst(Subexpression,InstantSolveSubst,solve(InstantSolveIntermediate,InstantSolveSubst)),
					  IF LISTP(Res) THEN
					    IF LENGTH(Res)=1 THEN 
					      Res:Res[1],Res
					      )$/* Block (instant solve) */
					      

/* #############################################################################################################
   ### YList: Dummy function that disappears as soon as it is evaluated.                                     ###
   ### It is displayed as a vertical list in Symaxx, while [] is a horizontal list.                          ###
   ### Only good to reduce screen clutter, don't confuse with a vertical vector!                             ###
   #############################################################################################################
*/
YLIST([x]):=x$

/* #############################################################################################################*/
/* ### SelSimp function                                                                                      ###*/
/* ### Takes an expression and simplifies all protected blocks.                                              ###*/
/* ### For example: SEL(a,Grp)+SEL(b,Grp) => SEL(a+b,Grp)                                                    ###*/
/* ### SEL(a,Grp)*SEL(b,Grp) => SEL(a*b,Grp)                                                                 ###*/
/* ### etc                                                                                                   ###*/
/* ### The Grp parameter is used to distinguish between independent selections.                              ###*/
/* #############################################################################################################*/
/* Test: 1-7 */

								

SelSimp(OrigExpr):=BLOCK(
	[SIMP:TRUE,Arg:[],LengthOfExpr,Count,Count1,Count2,SelSimpMode:FALSE],

/* Some conditions to abort */
	IF ATOM(OrigExpr) THEN RETURN(OrigExpr),
	BLOCK([INFLAG:TRUE],
		LengthOfExpr:LENGTH(OrigExpr)
	) /* Block with Simp off */,
	IF LengthOfExpr = 1 THEN RETURN(OrigExpr),
	IF INPART(OrigExpr,0) = "+" THEN SelSimpMode:"+",
	IF INPART(OrigExpr,0) = "*" THEN SelSimpMode:"*",
	/*ldisplay(SelSimpMode),*/
	if SelSimpMode = FALSE THEN RETURN(OrigExpr),

/* Turn the expression a+b+c into a list [a,b,c] */
	FOR Count:1 THRU LengthOfExpr DO BLOCK([SIMP:OFF],Arg:APPEND(Arg,[INPART(OrigExpr,Count)])),

/* If there is no or only one match, we can't do anything*/
	IF LENGTH(Arg) < 2 THEN return(OrigExpr),

/* Now repeat for as long as a match is found */
	catch(
	DO block([Result],	
		Result:CATCH(
			BLOCK(	[Matchlist:[]],
				BLOCK(	[INFLAG:TRUE],
					LengthOfExpr:LENGTH(Arg)
				),
/*Split the expression into a list and try the pattern match on each element*/
				Matchlist:GenerateMatchlist(Arg,LengthOfExpr),

				/* This will cause a THROW() */
	     			FindMatchingPairAndReassemble(MatchList,LengthOfExpr),
				THROW(FALSE)						
			)
		),
		if Result # FALSE then 
			Arg:Result 
		else
	/* Poor man's way of exiting the loop */
			THROW(0)
	)), /* DO, catch */
	IF LENGTH(Arg) = 1 THEN 
		RETURN(Arg[1]) 
	ELSE 
		RETURN(FUNMAKE(SelSimpMode,Arg))
)$ /* Block SelSimp */

FindMatchingPairAndReassemble(MatchList,LengthOfExpr):=
BLOCK([Hit],
	FOR Count1:1 THRU LengthOfExpr DO 
		FOR Count2 FROM Count1+1 THRU LengthOfExpr DO 
			block(	
			/* Now Hit contains the resulting expression, that combines the two expressions
			given by Count1 and Count2. */
			Hit:CheckHit(Matchlist,Count1,Count2),
			/*ldisplay(Hit),*/
/* A replacement was possible. Throw TRUE to indicate that we have to try again */
			if Hit # FALSE THEN THROW(ApplyHit(Count1,Count2,Matchlist,LengthOfExpr,Hit))	
			), /* block in FOR Count2 */
/*No replacement was possible: Tell the outer loop to stop*/
			THROW(FALSE)
)$


GenerateMatchlist(Arg,LengthOfExpr):=block([Count],
	FOR Count:1 THRU LengthOfExpr DO 
		BLOCK(	[CurrentMatch:FALSE,CurrentSubexpression],
			CurrentSubexpression:Arg[Count],
			if SelSimpMode = "+" then
				CurrentMatch:SelSimpMatch(CurrentSubexpression),
/* In *-mode we try to match for factor and power.
This works usually - for example a/SEL(...)^2, a/sqrt(SEL(...))
But the cases a/SEL(...) and SEL(...) are not matched.
Here we use the rule without the exponent, and add the 
exponent 1 afterwards to the list.*/
			if SelSimpMode ="*" then
				CurrentMatch:SelSimpMulMatch(CurrentSubexpression),
			if SelSimpMode ="*" and CurrentMatch=FALSE then
				block(
					CurrentMatch:SelSimpMulMatch2(CurrentSubexpression),
					if CurrentMatch # FALSE then 	
						CurrentMatch:append(CurrentMatch,['ProtPower=1])
				),
			if SelSimpMode ="*" and CurrentMatch=FALSE then
				block(
					CurrentMatch:SelSimpDivMatch(CurrentSubexpression),
					if CurrentMatch # FALSE then 	
						CurrentMatch:append(CurrentMatch,['ProtPower=-1])
				),
			Matchlist:APPEND(Matchlist,[CurrentMatch])
		), /* Block in for-loop*/	
	RETURN(Matchlist)
)$ /*GenerateMatchlist block */



ApplyHit(Count1,Count2,Matchlist,LengthOfExpr,Hit):=block([Count,ResultList:[]],
	FOR Count:1 THRU LengthOfExpr DO 
		IF Count # Count1 AND Count # Count2 THEN 
			ResultList:APPEND(ResultList,[Arg[Count]]),

	ResultList:APPEND(ResultList,[Hit]),
	RETURN(ResultList)
)$


CheckHit(Matchlist,Count1,Count2):=block(

	/*Independent of the mode, the following conditions have to be true:
	- First element has matched
	- Second element has matched
	- Protection groups of both elements are the same
	*/
	IF NOT(Matchlist[Count1] # FALSE 
	AND Matchlist[Count2] # FALSE
	AND SYMAXX_GetVar('ProtName,Matchlist[Count1]) = SYMAXX_GetVar('ProtName,Matchlist[Count2]) 
	AND SYMAXX_GetVar('ProtName,Matchlist[Count1]) # 'ProtName)
	THEN RETURN(FALSE),
	/* Case Match+Match 
	The parameters are ProtMul*SEL(ProtContent,ProtName)
	*/
	RETURN(CATCH(
	IF SelSimpMode = "+" THEN 
	BLOCK(	

		/*     Check for n*SEL(a,Grp)+m*SEL(a,GRP) => (n+m)*SEL(a,GRP)            */

		if SYMAXX_GetVar('ProtContent,Matchlist[Count1]) = SYMAXX_GetVar('ProtContent,Matchlist[Count2]) THEN
			THROW(
				(
				SYMAXX_GetVar('ProtMul,Matchlist[Count1])+
				SYMAXX_GetVar('ProtMul,Matchlist[Count2])
				)
				*SEL(
					SYMAXX_GetVar('ProtContent,Matchlist[Count1]),
					SYMAXX_GetVar('ProtName,Matchlist[Count1])
				) /* SEL */
			), /* THROW */


		/*     Check for n*SEL(a,Grp)+n*SEL(b,GRP) => n*SEL(a+b,GRP)            */

		if SYMAXX_GetVar('ProtMul,Matchlist[Count1]) = SYMAXX_GetVar('ProtMul,Matchlist[Count2]) THEN
			THROW(
				SYMAXX_GetVar('ProtMul,Matchlist[Count1])
				*SEL(
					SYMAXX_GetVar('ProtContent,Matchlist[Count1])
					+SYMAXX_GetVar('ProtContent,Matchlist[Count2]),
					SYMAXX_GetVar('ProtName,Matchlist[Count1])
				) /* SEL */
			) /* THROW */
	), /* Block if + */

	/* Case Match*Match
	The parameters are ProtMul*SEL(ProtContent,ProtName)^ProtPower */
	IF SelSimpMode = "*" THEN
	BLOCK(

	/* later additional conditions: exponent plus or minus. But in the meantime this will do. */
		if 1=1 THEN	
			THROW(
				SYMAXX_GetVar('ProtMul,Matchlist[Count1])*SYMAXX_GetVar('ProtMul,Matchlist[Count2])
				*SEL(
					SYMAXX_GetVar('ProtContent,Matchlist[Count1])^SYMAXX_GetVar('ProtPower,Matchlist[Count1])
					*SYMAXX_GetVar('ProtContent,Matchlist[Count2])^SYMAXX_GetVar('ProtPower,Matchlist[Count2]),
					SYMAXX_GetVar('ProtName,Matchlist[Count1])
				) /* SEL */
			) /*THROW*/
	), /* Block if * */
	THROW(FALSE)
	) /* CATCH */
	) /* RETURN */
)$ /*CheckHit*/ 


/* #############################################################################################################*/
/* ### SelSimp2 function                                                                                     ###*/
/* ### Takes an expression and simplifies all protected blocks.                                              ###*/
/* ### The rules are different than in SelSimp.                                                              ###*/
/* #############################################################################################################*/

/* Obsolete! */
defrule(SelSimp2,
 SEL(ProtContent,ProtName)+SEL(ProtContent2,ProtName)+ProtRest,
 SEL(ProtContent+ProtContent2,ProtName)+ProtRest
)$

/* Obsolete! */
defrule(SelSimp3,
 SEL(ProtContent,ProtName)+MinusOne*SEL(ProtContent2,ProtName)+ProtRest,
 SEL(ProtContent-ProtContent2,ProtName)+ProtRest
)$
/* #############################################################################################################
   ### StartProtect: Replaces all protected expressions by placeholders and puts them into a global array.   ###
   ### Should be used with Apply1.                                                                           ###
   ### A protected expression may contain other protected expressions. But that doesn't bother us here       ###
   ### - protected is protected!                                                                             ###
   #############################################################################################################
Test: 9
*/

defrule(
 SYMAXX_StartProtect,
 SEL(ProtContent,ProtName),
 CATCH(
  BLOCK([SIMP:ON,Count],         /* For adding 1 we need simplification! */
   IF NOT ATOM(SYMAXX_PROT_ARR) THEN
   FOR Count:1 THRU LENGTH(SYMAXX_PROT_ARR) DO
   IF SYMAXX_PROT_ARR[Count]=SEL(ProtContent,ProtName) THEN THROW(SYMAXX_PLACE_HOLDER[Count]),
   SYMAXX_PROT_ARR:APPEND(SYMAXX_PROT_ARR,[SEL(ProtContent,ProtName)]),
  THROW(SYMAXX_PLACE_HOLDER[length(SYMAXX_PROT_ARR)])
   ) /* Block */
) /* Catch */
)$ /* defrule StartProtect */


/* #############################################################################################################
   ### EndProtect: Replaces all placeholders generated by StartProtect from the global array.                ###
   ### Should be used with Apply1.                                                                           ###
   #############################################################################################################
Test: 10
*/

defrule(
	SYMAXX_EndProtect,
	SYMAXX_PLACE_HOLDER[SYMAXX_Placeholder_Number],
	SYMAXX_PROT_ARR[SYMAXX_Placeholder_Number]
)$ /* defrule EndProtect */

/* #############################################################################################################
   ### DefaultizeProtect: Replaces any SEL(Contents) with SEL(Contents,"")                                   ###
   ### This is necessary, otherwise other rules will not match!                                              ###
   #############################################################################################################
Test: 11
*/

defrule(
	SYMAXX_DefaultizeProtect,
	SEL(ProtContent),
	SEL(ProtContent,"")
)$ /* defrule DefaultizeProtect */
PrepareMatches$


/* This rule will unprotect every protected expression.
It has to be applied at the evaluation phase, where all the 
protected expressions are represented by their respective placeholders. */

DEFRULE(SYMAXX_UnprotectNoName,
	SYMAXX_PLACE_HOLDER[SYMAXX_Placeholder_Number],

/* The protect command is SEL(Content,Group).
	INPART:
	[0] is SEL,
	[1] is Content,
	[2] is Group.
	Here we are only interested in Content. */
	INPART(SYMAXX_PROT_ARR[SYMAXX_Placeholder_Number],1)
)$ /*defrule SYMAXX_UnprotectName*/

/*DEFRULE(SYMAXX_StripSubst,
        SYMAXX_SUBSTITUTE(SYMAXX_Anything),
      	SYMAXX_Anything
)$*/ /*defrule SYMAXX_StripSubst*/

/* This rule will unprotect every protected expression.
It has to be applied at the evaluation phase, where all the 
protected expressions are represented by their respective placeholders. */

DEFRULE(SYMAXX_UnprotectName,
	SYMAXX_PLACE_HOLDER[SYMAXX_Placeholder_Number],
	BLOCK([Group:INPART(SYMAXX_PROT_ARR[SYMAXX_Placeholder_Number],2)],
	IF SYMAXX_UNPROTECT_NAME # Group THEN
		SYMAXX_PROT_ARR[SYMAXX_Placeholder_Number]
	ELSE
	INPART(SYMAXX_PROT_ARR[SYMAXX_Placeholder_Number],1)
	) /* Block */
)$ /*defrule SYMAXX_UnprotectName*/

/* Same without using array */
/* Obsolete! */
DEFRULE(SYMAXX_UnprotectName_obsolete,
 SEL(ProtContent,ProtName),
 IF IS (ProtName # SYMAXX_UNPROTECT_NAME) then 
 SEL(ProtContent,ProtName) 
 ELSE ProtContent
)$ /*defrule SYMAXX_UnprotectName*/

/* Obsolete! */
DEFRULE(SYMAXX_UnprotectNoName_obsolete,
 SEL(ProtContent,ProtName),
 ProtContent
)$ /*defrule SYMAXX_UnprotectNoName*/

UNSEL(Expr,[MoreParams]):=block([Result],
 IF LENGTH(MoreParams)>1 then
 error("UNPROTECT only one or two parameters allowed"),
 IF LENGTH(MoreParams) =0 then
 Result:apply1(Expr,SYMAXX_UnprotectNoName),
 IF LENGTH(MoreParams) =1 then 
 block([SYMAXX_UNPROTECT_NAME:MoreParams[1]],
  Result:apply1(Expr,SYMAXX_UnprotectName)
  ), /* Block if only one parameter */
 Result
)$

SELPICK(StartExpr,[Args]):=block(
 [ProtName:FALSE,Result],
 if (LENGTH(Args)=1) THEN (
  ProtName:Args[1]),
 if (LENGTH(Args)>1) THEN (
  ERROR("SelPick only needs 0 or 1 arguments!")),
 StartExpr:apply1(StartExpr,SYMAXX_EndProtect),
 Result:SYMAXX_SELPICK(StartExpr,ProtName),
 Result:apply1(Result,SYMAXX_StartProtect),
 return(Result)
 ); /* Selpick */


SYMAXX_SELPICK(OrigExpr,ProtName):=CATCH(
 block([SubExpr,SubRes,LengthOfExpr,LengthOfSubexpr,Result:FALSE,ResultCount:0],
  IF ATOM(OrigExpr) THEN THROW(FALSE),
  block([INFLAG:TRUE],LengthOfExpr:LENGTH(OrigExpr)),/* Block(simp off) */
  /* Check for SEL(expr,Name) */  
  if LengthOfExpr=2 and INPART(OrigExpr,0)=SEL then (
   SubExpr:INPART(OrigExpr,1),
     /* Found a protected expression and no name was given */      
     IF ProtName=FALSE OR INPART(OrigExpr,2)=ProtName THEN (
      Result:SubExpr,
      ResultCount:ResultCount+1	
      )    
   ), /* If length OK and SEL(Expr,Name) */
  FOR Count:1 THRU LengthOfExpr DO BLOCK(    
   [SubExpr:INPART(OrigExpr,Count)],
   if not(ATOM(SubExpr)) then (
   
    /*Run SelPick on all subexpressions.*/
    SubRes:SelPick(SubExpr,ProtName),
    if SubRes # FALSE then (
     Result:SubRes,
     ResultCount:ResultCount+1
     ) /* If subresult */
   ) /* If not atom */
  ), /* For Count */
  if (ResultCount=1) THEN THROW(Result),
  if (ResultCount=0) THEN THROW(FALSE),
  ERROR("SELPICK: More than one match!")
 ) /* block */
)$ /* Catch */




SYMAXX_PROT_ARR:[]$ /* Initialize the array */


/* To run the selftest, set to TRUE. The tests will be executed until the end or until one of the tests fails. */
SYMAXX_SELFTEST:OFF$
if SYMAXX_SELFTEST = TRUE then block(
	/*SelSimp(a1*SEL(1,"bla")+a2*SEL(1,"bla")+a3*SEL(1,"bla")+b1*SEL(2,"bla")+b2*SEL(2,"bla")+b3*SEL(2,"bla"))*/
			Result:apply1(1/(a1*SEL(1,"bla")+a2*SEL(1,"bla")+a3*SEL(1,"bla")+b1*SEL(2,"bla")+b2*SEL(2,"bla")+b3*SEL(2,"bla")),SelSimp),
			if Result= 1/(SEL(2,"bla")*(b3+b2+b1)+SEL(1,"bla")*(a3+a2+a1)) then print("OK")
		else SYMAXX_SELFTEST:"Failed at SelSimp Test 1"
)$	
if SYMAXX_SELFTEST = TRUE then block(
	Result:apply1(SEL(u,1)*SEL(v,1),SelSimp),
	if Result=SEL(u*v,1) then print("OK") 
	else SYMAXX_SELFTEST:"Failed at SelSimp Test 2"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:apply1(SEL(a,1)/SEL(b,1),SelSimp),
	if Result=SEL(a/b,1) then print("OK") 
	else SYMAXX_SELFTEST:"Failed at SelSimp Test 3"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:apply1(SEL(a,"Group1")/SEL(b,"Group2"),SelSimp),
	if Result=SEL(a,"Group1")/SEL(b,"Group2") then print("OK") 
	else SYMAXX_SELFTEST:"Failed at SelSimp Test 4"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:apply1(SEL(a,"Group1")*sqrt(SEL(b,"Group1")),SelSimp),
	if Result=SEL(a*sqrt(b),"Group1") then print("OK") 
	else SYMAXX_SELFTEST:"Failed at SelSimp Test 5"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:apply1(SEL(a,"Group1")/sqrt(SEL(b,"Group1")),SelSimp),
	if Result=SEL(a/sqrt(b),"Group1") then print("OK") 
	else SYMAXX_SELFTEST:"Failed at SelSimp Test 6"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:apply1(SEL(a,1)*SEL(b,1)^2,SelSimp),
	if Result=SEL(a*b^2,1) then print("OK") 
	else SYMAXX_SELFTEST:"Failed at SelSimp Test 7"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:SelSimp(SEL(m^n,"Grp1")*SEL(o^p,"Grp1")),
	if Result=SEL(m^n*o^p,"Grp1") then print("OK") 
	else SYMAXX_SELFTEST:"Failed at SelSimp SEL(a)*SEL(b) => SEL(a*b) Test 7a"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:SelSimp(n*SEL(a,"Grp1")+n*SEL(b,"Grp1")),
	if Result=SEL(b+a,"Grp1")*n then print("OK") 
	else SYMAXX_SELFTEST:"Failed at SelSimp Test 7b"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:apply1(SEL(a,1)*SEL(b,1)^2,SYMAXX_StartProtect),
	if Result=SYMAXX_PLACE_HOLDER[1]*SYMAXX_PLACE_HOLDER[2]^2 then print("OK") 
	else SYMAXX_SELFTEST:"Failed at StartProtect Test 8"
)$

SYMAXX_PROT_ARR:[]$ /* Initialize the array, otherwise tests affect each other*/

if SYMAXX_SELFTEST = TRUE then block(
	Result:apply1(expand((SEL(a,"def")+SEL(b,"def"))^6),SYMAXX_StartProtect),
	if Result=SYMAXX_PLACE_HOLDER[2]^6+6*SYMAXX_PLACE_HOLDER[1]*SYMAXX_PLACE_HOLDER[2]^5+15*SYMAXX_PLACE_HOLDER[1]^2*SYMAXX_PLACE_HOLDER[2]^4+20*SYMAXX_PLACE_HOLDER[1]^3*SYMAXX_PLACE_HOLDER[2]^3+15*SYMAXX_PLACE_HOLDER[1]^4*SYMAXX_PLACE_HOLDER[2]^2+6*SYMAXX_PLACE_HOLDER[1]^5*SYMAXX_PLACE_HOLDER[2]+SYMAXX_PLACE_HOLDER[1]^6 then print("OK") 
	else SYMAXX_SELFTEST:"Failed at StartProtect Test 9"
);
if SYMAXX_SELFTEST = TRUE then block(
	Result:apply1(Result,SYMAXX_EndProtect),
	if factor(Result)=(SEL(b,"def")+SEL(a,"def"))^6 then print("OK") 
	else SYMAXX_SELFTEST:"Failed at EndProtect Test 10"
);
if SYMAXX_SELFTEST = TRUE then block(
	Result:apply1(SEL(a)*SEL(b)*SEL(c),SYMAXX_DefaultizeProtect),
	if factor(Result)=SEL(c,"")*SEL(b,"")*SEL(a,"") then print("OK") 
	else SYMAXX_SELFTEST:"Failed at DefaultizeProtect Test 11"
)$

Testexpr:SEL(a,"Grp1")*SEL(b,"Grp2")*SEL(c,"Grp2")$
/* Now we are testing the Unprotect rule.
This only works within a Protected-expression area.
So we apply StartProtect to Testexpr now.
To compare later, we have to apply EndProtect.
*/ 
Testexpr:apply1(Testexpr,SYMAXX_StartProtect)$


if SYMAXX_SELFTEST = TRUE then block(
	Result:UNSEL(Testexpr),
	if Result=a*b*c then print("OK") 
	else SYMAXX_SELFTEST:"Failed at Unprotect (no group) Test 12"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:UNSEL(Testexpr,"Grp1"),
	if Result=a*SEL(b,"Grp2")*SEL(c,"Grp2") then print("OK") 
	else SYMAXX_SELFTEST:"Failed at Unprotect (Grp1) Test 13"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:UNSEL(Testexpr,"Grp2"),
	if Result=SEL(a,"Grp1")*b*c then print("OK") 
	else SYMAXX_SELFTEST:"Failed at Unprotect (Grp2) Test 14"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:SELPICK(Testexpr,"Grp1"),
	if Result=a then print("OK") 
	else SYMAXX_SELFTEST:"Failed at Unprotect (Grp2) Test 14a"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:UNSEL(Testexpr,"Grp3"),
	if Result=apply1(Testexpr,SYMAXX_EndProtect) then print("OK") 
	else SYMAXX_SELFTEST:"Failed at Unprotect (unknown Grp) Test 15"
)$
if SYMAXX_SELFTEST = TRUE then block(
	Result:SYMAXX_GetVar(a4,[a0=1,a1=2,a2=4,a3=9,a4=16,a5=25]),
	if is(Result=16) then print("OK") 
	else SYMAXX_SELFTEST:"Failed at GetVar Test 16"
)$
TTYOFF:FALSE;NOLABELS:FALSE;
print("Test result: ",SYMAXX_SELFTEST)$
