package PopupManager;

# This package is somehow a thing of the past: There is only one 
# 'properties' window, which can deal with the properties of many
# hierarchy levels.
# It would be better to move the functionality somewhere else and remove
# this package entirely.

use Tk;
use strict;
use Symaxx2::MainDialog;
use Symaxx2::Palette;
sub New{
    my $self={};
    bless $self;
    return $self;
};

sub Open{ 
    my $self=shift or die;
    my %P=@_;
    my $What=$P{'WHAT'} or die;
    if (!($self->{$What} && $self->{$What}->AreYouOK)){
	my $NewDialog;
	if ($What eq 'THING_GLOBAL'){
	    $NewDialog=MainDialog->New(MAINWIN=>$::MainWin); 
	};
	die unless $NewDialog;
	$self->{$What}=$NewDialog;
    }; # if window does already exist
    $self->SetContext(%P);
};
sub SetContext{
    my $self=shift or die;
    my %P=@_;
    my $What=$P{'WHAT'} or return;
    if ($self->{$What} && $self->{$What}->AreYouOK){
	$self->{$What}->SetContext(%P);
    };
};
sub Reinit{
    # Call this, when the contents (widget structure) of a window have changed.
    my $self=shift or die;
    my %P=@_;
    my $What=$P{'WHAT'} or die;
    if ($self->{$What} && $self->{$What}->AreYouOK){
	my $OldContext=$self->{$What}->QueryContext;
	$self->{$What}->Destroy;
	$self->Open(WHAT => 'THING_GLOBAL',%{$OldContext});
    };
};
sub ReinitAll{ 
    my $self=shift or die;
    $self->Reinit(WHAT => 'THING_GLOBAL');

    # Destroy the palette. Rebuild it.
    if ($self->{'PALETTE'} && $self->{'PALETTE'}->AreYouOK){	
	$self->TogglePalette;
	$self->TogglePalette;
    };
};
sub TogglePalette{
    my $self=shift or die;
    if (!$self->{'PALETTE'} || !$self->{'PALETTE'}->AreYouOK){
	$self->{'PALETTE'}=Palette::New;
    } else {
	$self->{'PALETTE'}->destroy; 
	delete $self->{'PALETTE'};
    };
};
1;
