package Preferences;
use strict;
# The following variables can be modified by the user / administrator.

# Leave $::TempDir empty in the production release. It will be created with a random name in /tmp then.
# $::TempDir='/tmp/symaxx2tmp';

# Note: DO NOT delete any of the following entries!

# This should point to a directory, where the files
# maxima_toc.html and intro.html are located.
$::MaximaDocDir='/usr/local/lib/';

# Path to PDF viewer.
# Feel free to replace any entry with an absolute path (i.e. /home/me/bin/acroread3/acroread)
# Put your preferred viewer as first item into the list.
@::PDFViewer=('acroread','xpdf','ghostview');
# My ghostview has problems to turn back a page. But it's better than nothing.

# Same for HTML viewer
# Open a new terminal window for lynx.
@::HTMLBrowser=('netscape','arena','xterm -geometry 120x40+10+10 -e lynx');

# Maxima path
$::Maxima='maxima';

# Any colour you like for the background, for example 'black', 'darkgray'
$::MainWinBackground='white';

# font geometry for graphical math
# Default font in global variable for fast access
$::FontHeight=12;
# Other fonts in array
$::FontHeight_{HEADING3}=16;
$::FontHeight_{HEADING2}=24;
$::FontHeight_{HEADING1}=33;

# Default size of main window
$::DefaultGeometry='900x600+50+50';

# When new expressions are created without using the mouse, how much
# space should be left between them?
$::DefaultYStepInEditor=70;
 
# Paper geometry for printing:
# One Dot is 1/72 inch, one inch is 2.54 cm
# A4-page (printable area): approx. 17 x 26 cm
$::PaperwidthInDots=17*72/2.54;    # x*72/2.54 cm
$::PaperheightInDots=26*72/2.54;   # or y*72 inches

# Maximasource is needed to run self tests, otherwise not (debug only)
$::MaximaSource='/usr/src/packages/SOURCES/Maxima/maxima-5.5';

# The 'Watchdog' is the button that pops up after WatchdogAlertTime second(s).
# If it is disabled, press Ctrl-C in the console window to
# abort an evaluation.
$::WatchdogEnabled=1;
$::WatchdogAlertTime=2;

# Not all numbers can be represented exactly as a float. Therefore, some numerical results are very unpractical (1.1000000000001).
# Symaxx tries to guess what's noise and what not.
# By default it will chop off the trailing digit, when there are at least 6 '0' digits in front of it. So 1.0000009 will be chopped to 1, but 1.000001 will be left unchanged.
# However, disable the whole procedure by setting $::DoNotRound
$::DoNotRound=0;

# Turn this on to enable the units.mc package and the highlighting of units and unit abbreviations by default.
$::MaximaUseUnits=0;

# Turn this on to enable the Gnuplot interface
$::MaximaUseGnuplot=1;

# Here you can turn off the help 'balloons'.
$::BalloonHelp=1;

# Some redundant information about the data is buffered. This speeds up
# Symaxx, but takes more memory. Turn it off here, if you have memory problems.
# Saves maybe 5 %
$::ConserveMemory1=0;

# Comment this out to get rid of the INPART: message, when pressing the mouse button.
# Note: This is not debug code. For example, if INPART shows 1,1,2 , then you can use INPART(Expr,1,1,2) to retrieve the clicked expression.
$::INPARTPath='';

# Counters for objects (memory leak debugging)
# Uncomment them, and an object counter appears in the menu line
# This does not work after loading!
# $::GOCount=0;
# $::LispListCount=0;

# Alternative save / load mechanism, less security risks than the evaluation
# of perl code, when loading a file. Slow, don't use!
# The file formats are incompatible!
# $::FileOpenParanoia=0; suspended until further notice

# Highlight known key words
$::GlobalFontLock=1;
1;
